﻿#region

using System;
using System.Linq;
using System.Windows.Forms;
using SystemFileSample1.MyClass.Part;
using SystemFileSample1.MyClass.Seller;

#endregion

namespace SystemFileSample1
{
    public partial class FrmSelect : Form
    {
        #region SelectType enum

        public enum SelectType
        {
            Part,
            Seller
        }

        #endregion

        /// <summary>
        ///   برای مشخص بودن نوع انتخاب
        /// </summary>
        /// <param name = "selectType">برای انتخاب رکورد مورد نظر از درون فایل مورد نظر</param>
        public FrmSelect(SelectType selectType)
        {
            InitializeComponent();

            if (selectType == SelectType.Part)
            {
                dgvPart.Visible = true;
                dgvPart.DataSource = Parts.AllParts.ToList();
            }
            else
            {
                dgvSeller.Visible = true;
                dgvSeller.DataSource = Sellers.AllSellers.ToList();
            }
        }

        public string StrCode { get; set; }

        private void DgvPartCellClick(object sender, DataGridViewCellEventArgs e)
        {
            if (dgvPart == null || dgvPart.Columns[e.ColumnIndex].Name != "btnPartSelecting") return;
            StrCode = dgvPart["PartId", e.RowIndex].Value.ToString();
            Close();
        }

        private void DgvSellerCellClick(object sender, DataGridViewCellEventArgs e)
        {
            if (dgvSeller.Columns[e.ColumnIndex].Name == "btnSellerSelecting")
            {
                StrCode = dgvSeller["SellerCode", e.RowIndex].Value.ToString();
                Close();
            }
        }
    }
}